<template>
  <div class="beneficiary-documents-select">
    <AtomSearchableSelect
      v-if="!pending && !error"
      class="beneficiary-documents-search"
      :name="name"
      :label="label"
      :options="documentOptions"
      :value="value"
      multiple
    />

    <BeneficiaryDocumentAdd
      :beneficiary-id="beneficiaryId"
      @added="onDocumentAdded"
    />
  </div>
</template>

<script setup>
  import { getRandomId } from '~~/utils/random'

  const { $loadBeneficiaryDocuments, $snackbar } = useNuxtApp()

  const props = defineProps({
    beneficiaryId: { type: String, required: true },
    label: { type: String, required: true },
    name: { type: String, required: true },
    value: { type: Array, default: undefined },
    helpRequest: { type: Boolean, default: true }
  })

  const {
    data: documents,
    pending,
    error
  } = useLazyAsyncData(getRandomId('documents'), loadDocuments, {
    server: false
  })

  const documentOptions = computed(
    () => new Map(documents.value.map(d => [d.id, d.filename_download]))
  )

  async function loadDocuments() {
    return await $loadBeneficiaryDocuments(props.beneficiaryId)
  }

  function onDocumentAdded(document) {
    documents.value.push(document)
    $snackbar.success(
      `Le document a été ajouté à la fiche bénéficiaire. Enregistrez ${
        props.helpRequest
          ? "l'instruction de demande d'aide"
          : "la synthèse d'entretien"
      } pour conserver le lien entre les deux.`
    )
  }
</script>

<style scoped>
  .beneficiary-documents-select {
    display: flex;
    align-items: flex-end;
    width: 100%;
  }

  .beneficiary-documents-search {
    margin-bottom: 0;
    margin-right: 2rem;
    flex: 1;
  }
</style>
